#!/bin/sh

# Write this process id to the file
echo $$ > /tmp/`basename $0`.pid

# Function to restart all applications
restart_apps()
{
	PATH=/bin:/sbin:/usr/bin:/usr/sbin
	/etc/init.d/S50crond  stop	| logger
        # sleep a while to avoid race conditions
        sleep 2
	/etc/init.d/S56snmpagent stop | logger
	/etc/init.d/S55transcan stop	| logger
	/etc/init.d/S54openslp stop	| logger
	/etc/init.d/S45chrony stop	| logger
	/etc/init.d/S40network stop	| logger

	sleep 2

	/etc/init.d/S40network start	| logger
	/etc/init.d/S45chrony start	| logger
	/etc/init.d/S54openslp start	| logger
	/etc/init.d/S55transcan start	| logger
	/etc/init.d/S56snmpagent start | logger
	/etc/init.d/S50crond  start	| logger
}

# Function to restart all applications
restart_agent()
{
	/etc/init.d/S56snmpagent restart
}

trap 'restart_apps' USR1   # On SIGUSR1, restart applications
trap 'restart_agent' USR2   # On SIGUSR2, restart snmpagent

# Endless loop until killed by signal 15 (etc.):
while true ; do
	sleep 1
done
